2013 ACM/ICPC Asia Regional Online —— Warmup2 ABEGKL

HDU4716 A. A Computer Graphics Problem

A题目描述

题意:输出手机剩余电量,保证给出的数是10的倍数。

题解:水题,按题意输出即可。

代码:

#include <cstdio>
#include <cstring>
#include <algorithm>
#define ll long long
using namespace std;
int main() {
    int T,t=1,n,m;
    for (scanf("%d",&T);t <= T; t++) {
        scanf("%d",&n);
        n = n/10;
        m = 10 - n;
        printf("Case #%d:
*------------*
",t);
        for (int i = 1; i <= m; i++) printf("|............|
");
        for (int i = 1; i <= n; i++) printf("|------------|
");
        printf("*------------*
");
    }
    return 0;
}
A题代码

HDU4717 B. The Moving Points

B题目描述

题意:告诉你n个点的坐标和他们移动的速度,问你什么时候任意两个点的最大距离最小,以及这个距离是多少。

题解:最大值最小问题我们可以想到二分,点移动可以看成一条线,两条直线的位置关系有平行(重合)和相交,平行(重合)的话他们的距离并不会变,相交的话,这两个点之间的距离可能先变小再变大。我们不能想到这个一个开口向上的二次函数,那么我们三分求解即可得到答案。

代码:

#include <cstdio>
#include <cstring>
#include <algorithm>
#define ll long long
using namespace std;
const int N = 300 + 10;
const double esp = 1e-6;
int x[N],y[N],vx[N],vy[N];
int n;
double cal(double t) {
    double ans = 0;
    for (int i = 0; i < n; i++) {
        for (int j = i+1; j < n; j++) {
            double x1 = x[i] + vx[i]*t;
            double y1 = y[i] + vy[i]*t;
            double x2 = x[j] + vx[j]*t;
            double y2 = y[j] + vy[j]*t;
            ans = max(ans,sqrt((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2)));
        }
    }
    return ans;
}
int main() {
    int T,cas = 1;
    for (scanf("%d",&T);cas <= T; cas++) {
        scanf("%d",&n);
        for (int i = 0; i < n; i++)
            scanf("%d%d%d%d",&x[i],&y[i],&vx[i],&vy[i]);
        double t,ans,l = 0, r = 1e10;
        while (r - l > esp) {
            double mid = (l+r)/2;
            double mmid = (mid + r)/2;
            double l1 = cal(mid);
            double l2 = cal(mmid);
            if (l2 - l1 > esp) r = mmid-esp;
            else l = mid +esp;
        }
        t = l;
        ans = cal(t);
        printf("Case #%d: %.2f %.2f
",cas,t,ans);
    }
    return 0;
}
B题代码

HDU4720 E. Naive and Silly Muggles 

Three wizards are doing a experiment. To avoid from bothering, a special magic is set around them. The magic forms a circle, which covers those three wizards, in other words, all of them are inside or on the border of the circle. And due to save the magic power, circle's area should as smaller as it could be. 
Naive and silly "muggles"(who have no talents in magic) should absolutely not get into the circle, nor even on its border, or they will be in danger. 
Given the position of a muggle, is he safe, or in serious danger?

Input
The first line has a number T (T <= 10) , indicating the number of test cases. 
For each test case there are four lines. Three lines come each with two integers x i and y i (|x i, y i| <= 10), indicating the three wizards' positions. Then a single line with two numbers q x and q y (|q x, q y| <= 10), indicating the muggle's position.

Output
For test case X, output "Case #X: " first, then output "Danger" or "Safe".

Sample Input
3
0 0
2 0
1 2
1 -0.5

0 0
2 0
1 2
1 -0.6

0 0
3 0
1 1
1 -1.5

Sample Output
Case #1: Danger
Case #2: Safe
Case #3: Safe
E题目描述

题意:给出三个巫师的坐标A(x1,y2)、B(x2,y2)、C(x3,y3)和一个非魔法界的人的坐标D,如果坐标D在包含坐标ABC组成的最小的圆里面的话输出Danger,否则输出Safe。

题解:但ABC在一条直线上或者ABC组成的三角形是钝角三角形时,最小圆的圆心为距离最远的两个点的中心。否则的话,我们可以通过公式算出圆心坐标:

  x=((y2*y2-y1*y1+x2*x2-x1*x1)*(y3-y1)-(y3*y3-y1*y1+x3*x3-x1*x1)*(y2-y1))/(2*((y3-y1)*(x2-x1)-(y2-y1)*(x3-x1)));
       y=(y2*y2-y1*y1+x2*x2-x1*x1-2*x2*x+2*x1*x)/(2*(y2-y1));

我们要注意y2不能等于y1所以我们在计算之前要判断一下A和B的纵坐标是否相同,如果相同的话将A和C的坐标互换一下。(因为此时ABC一定能组成三角形,所以最多两个点纵坐标相同)。

代码:

#include <cstdio>
#include <cstring>
#include <algorithm>
#define ll long long
using namespace std;
const int N = 1e5 + 10;
struct Point{
    double x,y;
}a[3],p,b[2],o;
double dis(Point i,Point j) {
    return (i.x-j.x)*(i.x-j.x)+(i.y-j.y)*(i.y-j.y);
}
int main() {
    int T,t=1;
    for (scanf("%d",&T);t <= T; t++) {
        for (int i = 0; i < 3; i++)
            scanf("%lf%lf",&a[i].x,&a[i].y);
        scanf("%lf%lf",&p.x,&p.y);
        double ma = 0,sum = 0;
        int u,v,cnt = 0;
        double len[3];
        for (int i = 1; i < 3; i++)
            for (int j = 0; j < i; j++) {
                len[cnt++] = dis(a[i],a[j]);
                sum += len[cnt-1];
                if (ma < len[cnt-1]) {
                    ma = len[cnt-1]; u = i; v = j;
                }
            }
        b[0] = a[u],b[1] = a[v];
        bool fg = false;
        if ((a[1].x-a[0].x)*(a[2].y-a[0].y) == (a[2].x-a[0].x)*(a[1].y-a[0].y)) {
            o.x = (b[0].x+b[1].x)/2;
            o.y = (b[0].y+b[1].y)/2;
            double l1 = dis(o,b[0]);
            double l2 = dis(o,p);
            if (l2 - l1 < 1e-6) fg = true;
        }else {
            if (sum - ma < ma) {//钝角
                o.x = (b[0].x+b[1].x)/2;
                o.y = (b[0].y+b[1].y)/2;
                double l1 = dis(o,b[0]);
                double l2 = dis(o,p);
                if (l2 - l1 < 1e-6) fg = true;
            }else {
                if (a[0].y == a[1].y) swap(a[0],a[2]);
                double x = p.x;
                double x1 = a[0].x,y1 = a[0].y;
                double x2 = a[1].x,y2 = a[1].y;
                double x3 = a[2].x,y3 = a[2].y;
                o.x=((y2*y2-y1*y1+x2*x2-x1*x1)*(y3-y1)-(y3*y3-y1*y1+x3*x3-x1*x1)*(y2-y1))/(2*((y3-y1)*(x2-x1)-(y2-y1)*(x3-x1)));
                o.y=(y2*y2-y1*y1+x2*x2-x1*x1-2*x2*x+2*x1*x)/(2*(y2-y1));
                double l1 = dis(o,a[0]);
                double l2 = dis(o,p);
                if (l2 - l1 < 1e-6) fg = true;
            }
        }
        printf("Case #%d: %s
", t,fg?"Danger":"Safe");
    }
    return 0;
}
View Code

HDU4722 G. Good Numbers

If we sum up every digit of a number and the result can be exactly divided by 10, we say this number is a good number. 
You are required to count the number of good numbers in the range from A to B, inclusive.

Input
The first line has a number T (T <= 10000) , indicating the number of test cases. 
Each test case comes with a single line with two numbers A and B (0 <= A <= B <= 10^18).

Output
For test case X, output "Case #X: " first, then output the number of good numbers in a single line.

Sample Input
2
1 10
1 20

Sample Output
Case #1: 0
Case #2: 1

        
  
Hint
The answer maybe very large, we recommend you to use long long instead of int.
G题目描述

题意:给你两个数A,B(0 <= A <= B <= 1018),问A到B之间(包括A,B)有多少个数满足它的每一位数之和是10的倍数。

题解:通过打表我们发现0~10有1个,0~100有10个,0~1000有100个,所以如果一个数x是10的倍数,那么0~x就有x/10个满足条件的数。那么如果这个数不是10的倍数呢?我们可以先把前几位求和,然后从0到x%10枚举有几个数满足条件,在加上x/10,就是0~x中满足条件的数的个数。

代码:

#include <cstdio>
#include <cstring>
#include <algorithm>
#define ll long long
using namespace std;
const int N = 1e5 + 10;
ll cal(ll x) {
    ll y = x/10*10,z = x%10,sum = 0, ans = 0;
    while (y) {
        sum += y%10; y /= 10;
    }
    for (ll i = 0; i <= z; i++)
        if ( (sum + i)%10 == 0 ) ans++;
    return ans;
}
ll work(ll x) {
    return x/10+cal(x);
}
int main() {
    int T,t=1;
    for (scanf("%d",&T);t <= T; t++) {
        ll n,m;
        scanf("%lld%lld",&n,&m);
        printf("Case #%d: %lld
", t, work(m)-work(n-1));
    }
    return 0;
}
G题代码

HDU4726 K.Kia's Calculation 

Doctor Ghee is teaching Kia how to calculate the sum of two integers. But Kia is so careless and alway forget to carry a number when the sum of two digits exceeds 9. For example, when she calculates 4567+5789, she will get 9246, and for 1234+9876, she will get 0. Ghee is angry about this, and makes a hard problem for her to solve:
Now Kia has two integers A and B, she can shuffle the digits in each number as she like, but leading zeros are not allowed. That is to say, for A = 11024, she can rearrange the number as 10124, or 41102, or many other, but 02411 is not allowed. 
After she shuffles A and B, she will add them together, in her own way. And what will be the maximum possible sum of A "+" B ?

Input
The rst line has a number T (T <= 25) , indicating the number of test cases. 
For each test case there are two lines. First line has the number A, and the second line has the number B. 
Both A and B will have same number of digits, which is no larger than 10 6, and without leading zeros.

Output
For test case X, output "Case #X: " first, then output the maximum possible sum without leading zeros.

Sample Input
1
5958
3036

Sample Output
Case #1: 8984
K题目描述

题意:给你两个数A,B,你可以将它们重新排列(但不能有前导零),例如A=3036,你可以把它看成6330也可以把它看成3360,但不能看成0336。 然后再将它们每一位对应做不进位的加法(保证位数相同),问结果进行加法计算之后的结果最大是多少(不含前导零)。

题解:拿两个数组分别记录A和B中0~9的数量,然后贪心。

   注意最高位数不能有0。

   还要注意最高位加起来%10==0的情况。

  PS:做题时以为是A、B大小不超过10^6,结果是位数不超过10^6,结果一直WA。

代码:

#include <cstdio>
#include <cstring>
#include <algorithm>
#define ll long long
using namespace std;
const int N = 1e6 + 10;
char s1[N],s2[N];
int a[N],b[N];
int main() {
    int T,t=1;
    for (scanf("%d",&T);t <= T; t++) {
        scanf("%s%s",s1,s2);
        printf("Case #%d: ", t);
        int num1[10]={0},num2[10]={0};
        int len = strlen(s1);
        for (int i = 0; i < len; i++) {
            a[i] = s1[i]-'0';
            b[i] = s2[i]-'0';
            num1[a[i]]++;
            num2[b[i]]++;
        }
        int x = 0;
        pair<int,int> id;
        id.first = id.second = 0;
        for (int i = 1; i <= 9; i++) {
            for (int j = 1;num1[i]>0 && j <= 9; j++) {
                if (num2[j] > 0 && (i+j)%10 >= x) {
                    x = (i+j)%10;
                    id.first = i;
                    id.second = j;
                    if(x==9) break;
                }
            }
        }
        bool fg = false;
        if (x>0) fg = true;
        if (fg) printf("%d",x);
        num1[id.first]--;
        num2[id.second]--;
        for (int k = 1; k < len; k++) {
            x = 0;
            for (int i = 0; i < 10; i++) {
                for (int j = 0;num1[i]>0 && j < 10; j++) {
                    if (num2[j]>0 && (i+j)%10 >= x) {
                        x = (i+j)%10;
                        id.first = i;
                        id.second = j;
                        if (x == 9) break;
                    }
                }
            }
            if (!fg && x>0) fg = true;
            if (fg) printf("%d",x);
            num1[id.first]--;
            num2[id.second]--;
        }
        if (!fg) printf("0");
        printf("
");
    }
    return 0;
}
View Code

HDU4727 L. The Number Off of FFF 

X soldiers from the famous " *FFF* army" is standing in a line, from left to right. 
You, as the captain of *FFF*, decides to have a "number off", that is, each soldier, from left to right, calls out a number. The first soldier should call "One", each other soldier should call the number next to the number called out by the soldier on his left side. If every soldier has done it right, they will call out the numbers from 1 to X, one by one, from left to right. 
Now we have a continuous part from the original line. There are N soldiers in the part. So in another word, we have the soldiers whose id are between A and A+N-1 (1 <= A <= A+N-1 <= X). However, we don't know the exactly value of A, but we are sure the soldiers stands continuously in the original line, from left to right. 
We are sure among those N soldiers, exactly one soldier has made a mistake. Your task is to find that soldier.

Input
The rst line has a number T (T <= 10) , indicating the number of test cases. 
For each test case there are two lines. First line has the number N, and the second line has N numbers, as described above. (3 <= N <= 10 5) 
It guaranteed that there is exactly one soldier who has made the mistake.

Output
For test case X, output in the form of "Case #X: L", L here means the position of soldier among the N soldiers counted from left to right based on 1.

Sample Input
2
3
1 2 4
3
1001 1002 1004

Sample Output
Case #1: 3
Case #2: 3
L题目描述

题意:给你一个长度为n的序列,已知里面的元素依次应该为x~x+n,但是里面有且仅有一个元素错了,找出这个元素的下标(下标从1开始)。

题解:一个for循环判断当前元素是否等于前一个元素+1,不同的话就代表当前元素错了。但是要注意,如果错了的元素是第二个的话,可能是第一个错了,需要判断一下第2个元素+1是否等于第3个元素,是的话就是1错了。还要注意的一个点是如果整个序列都是对的,那么输出1,因为题目说了有1个错了。

代码:

#include <cstdio>
#include <cstring>
#include <algorithm>
#define ll long long
using namespace std;
const int N = 1e5 + 10;
int a[N];
int main() {
    int T,t=1;
    for (scanf("%d",&T);t <= T; t++) {
        int n,ans = 1;
        scanf("%d",&n);
        for (int i = 1; i <= n; i++) scanf("%d",&a[i]);
        for (int i = 2; i <= n; i++)
            if (a[i] != a[i-1]+1) {
                ans = i;
                break;
            }
        if (ans == 2 && a[2]+1 == a[3]) ans = 1;
        printf("Case #%d: %d
", t, ans);
    }
    return 0;
}
View Code
原文地址:https://www.cnblogs.com/l999q/p/11402700.html